% Plan de Mision de validacion
% Parametros iniciales
m_fuel     = 272; %Fuel weight (kg)       
NUM_MPLANS = 4;   %Number of Stages       
NUM_STAGES = 9;   %Number of Mission Plans
missionDefinition = NaN(NUM_STAGES, LONGTRAMA, NUM_MPLANS);
load chart_data_cv.mat;

% ------------------ MAIN PLAN ------------------
PLAN=1; k=0;

k=k+1;
% IF RPAS loiter point
missionDefinition(k, CODING,   PLAN) = IF;
missionDefinition(k, FIX1LAT,  PLAN) = 40.3164;
missionDefinition(k, FIX1LON,  PLAN) = -1.1856;
missionDefinition(k, FIX1ALT,  PLAN) = 5500;
missionDefinition(k, LIMSPEED, PLAN) = 150/mph2knot;

k=k+1;
% ORBIT TO ALT: min altitude for AWY R29
missionDefinition(k, CODING,   PLAN) = ORBIT;
missionDefinition(k, FIX1LAT,  PLAN) = 40.3164;
missionDefinition(k, FIX1LON,  PLAN) = -1.1856;
missionDefinition(k, RADIUS,   PLAN) = .5; %nm
missionDefinition(k, DIR,      PLAN) = 1; %CW
missionDefinition(k, ENDTYPE,  PLAN) = ALT_TYPE;
missionDefinition(k, LIMVALUE, PLAN) = 9500;

k=k+1;
% FLYTO intercept AWY R29, CMA169040/N0150F110
[lat,lon] = orto_reckon(navaid_cma.lat, navaid_cma.lon, 40*nm2m, 169);
[~, crs]  = orto_distazi(lat, lon, wp_sobro.lat, wp_sobro.lon);
missionDefinition(k, CODING,   PLAN) = FLYTO;
missionDefinition(k, FIX1LAT,  PLAN) = lat;
missionDefinition(k, FIX1LON,  PLAN) = lon;
missionDefinition(k, COURSE,   PLAN) = crs;
missionDefinition(k, FIX1ALT,  PLAN) = 11000;
missionDefinition(k, FIX2ALT,  PLAN) = 11000;
missionDefinition(k, LIMSPEED, PLAN) = 150/mph2knot;

k=k+1;
% TF to SOBRO (antes de llegar)
missionDefinition(k, CODING,   PLAN) = TF;
missionDefinition(k, FIX1LAT,  PLAN) = wp_sobro.lat;
missionDefinition(k, FIX1LON,  PLAN) = wp_sobro.lon;
missionDefinition(k, LIMSPEED, PLAN) = 150/mph2knot;

k=k+1;
% SCAN Albufera
missionDefinition(k, CODING,   PLAN) = SCAN;
missionDefinition(k, FIX1LAT,  PLAN) = dms2degrees([39 21 00]);
missionDefinition(k, FIX1LON,  PLAN) = dms2degrees([0 -24 30]);
missionDefinition(k, FIX2LAT,  PLAN) = dms2degrees([39 19 00]);
missionDefinition(k, FIX2LON,  PLAN) = dms2degrees([0 -18 00]);
missionDefinition(k, COURSE,   PLAN) = 160;
missionDefinition(k, RADIUS,   PLAN) = 1000/1852; %NM
missionDefinition(k, FIX1ALT,  PLAN) = 2000;
missionDefinition(k, LIMSPEED, PLAN) = 100;

k=k+1;
% CF Pasillo visual Sollana
missionDefinition(k, CODING,   PLAN) = CF;
missionDefinition(k, FIX1LAT,  PLAN) = navaid_vlc.lat;
missionDefinition(k, FIX1LON,  PLAN) = navaid_vlc.lon;
missionDefinition(k, COURSE,   PLAN) = 340;
missionDefinition(k, FIX1ALT,  PLAN) = 6500+get_terrain_elevation(navaid_vlc.lat, navaid_vlc.lat);
missionDefinition(k, FIX2ALT,  PLAN) = 19500;
missionDefinition(k, LIMSPEED, PLAN) = 130/mph2knot;

k=k+1;
% CF Pasillo visual El Puig
missionDefinition(k, CODING,   PLAN) = CF;
missionDefinition(k, FIX1LAT,  PLAN) = sex2dec('393538N');
missionDefinition(k, FIX1LON,  PLAN) = sex2dec('0001801W');
missionDefinition(k, COURSE,   PLAN) = 53;
missionDefinition(k, FIX1ALT,  PLAN) = 9500;
missionDefinition(k, FIX2ALT,  PLAN) = 19500;
missionDefinition(k, LIMSPEED, PLAN) = 130/mph2knot;

k=k+1;
% CF Pasillo visual Sagunto
missionDefinition(k, CODING,   PLAN) = CF;
missionDefinition(k, FIX1LAT,  PLAN) = sex2dec('393922N');
missionDefinition(k, FIX1LON,  PLAN) = sex2dec('0001244W');
missionDefinition(k, COURSE,   PLAN) = 48;
missionDefinition(k, FIX1ALT,  PLAN) = 9500;
missionDefinition(k, FIX2ALT,  PLAN) = 19500;
missionDefinition(k, LIMSPEED, PLAN) = 130/mph2knot;
%
%%
k=k+1;
%FLYTO SOPET
missionDefinition(k, CODING,   PLAN) = FLYTO;
missionDefinition(k, FIX1LAT,  PLAN) = wp_sopet.lat;
missionDefinition(k, FIX1LON,  PLAN) = wp_sopet.lon;
missionDefinition(k, FIX1ALT,  PLAN) = 9500;
missionDefinition(k, LIMSPEED, PLAN) = 130/mph2knot;