function setPosXPLANE(ip,port,local_x,local_y,local_z)
% Asensio Lorenzo 15/06/16

% Modify Xplane plane position via UDP :
%
% local_x  / sim/flightmodel/position/local_x   double 
% local_y  / sim/flightmodel/position/local_y   double
% local_z  / sim/flightmodel/position/local_z   double
%
% Out of range values are ignored by writeXPLANE.
% ip   : IP address of Xplane / Example: '127.0.0.1'
% port : port of Xplane / Integer / Example: 9005

dataref_x= 'sim/flightmodel/position/local_x';
dataref_y= 'sim/flightmodel/position/local_y';
dataref_z= 'sim/flightmodel/position/local_z';

ssock = java.net.DatagramSocket();
UDPsendDREFfloat(ssock,ip,port,dataref_x,local_x);
UDPsendDREFfloat(ssock,ip,port,dataref_y,local_y);
UDPsendDREFfloat(ssock,ip,port,dataref_z,local_z);
ssock.close();

end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function UDPsendDREFfloat(ssock,ip,port,dataref,value)
dataref(500) = 0; % Fixed length

intro_bytes   = uint8(['DREF' 0]);
value_bytes   = typecast(single(value),'uint8');
dataref_bytes = uint8(dataref);

send_msg = [intro_bytes value_bytes dataref_bytes];

send_pkt = java.net.DatagramPacket(send_msg, size(send_msg,2),...
           java.net.InetAddress.getByName(ip),port);
ssock.send(send_pkt);
end
